CalendarFu = Rock:NewAddon("CalendarFu", "LibFuBarPlugin-3.0", "LibRockConfig-1.0");

-- using LibRockConfig-1.0, this will automatically
-- open with the FuBar plugin when right-clicked.
CalendarFu:SetConfigTable({
    name = "FuBar_CalendarFu",
    desc = "FuBar icon for the in-game calendar.",
    type = 'group',
    args = {}
});

function CalendarFu:IsValue()
	return true;
end;
function CalendarFu:ToggleValue()
	return true;
end;

function CalendarFu:OnUpdateFuBarText()
    self:SetFuBarText('CalendarFu');
end;

function CalendarFu:OnUpdateFuBarTooltip()
    GameTooltip:AddLine("CalendarFu");
    
    -- make sure that the calendar is actually loaded, or else this won't work
	if (not IsAddOnLoaded("Blizzard_Calendar")) then
		UIParentLoadAddOn("Blizzard_Calendar");
	end;
    
    -- Add list of events for today
    GameTooltip:AddLine("Events for today:", 1, 1, 1);
    _, _, day, _ = CalendarGetDate();
    if (CalendarGetNumDayEvents(0, day) == 0) then
    	GameTooltip:AddLine("none", 1, 0, 0);
    else
    	local hasEntries = false;
    	local cHour			= tonumber(date('%H'));
    	local cMin			= tonumber(date('%M'));
    	
    	for i = 1, CalendarGetNumDayEvents(0, day) do
    		local title, hour, minute, calendarType, sequenceType = CalendarGetDayEvent(0, day, i);
			if(sequenceType == 'ONGOING') then
				-- ignore
			else
				if (cHour < (hour-1) or (cHour < hour and cMin < minute)) then
					-- we're way early ( > 1 hr)
					GameTooltip:AddDoubleLine(title, string.format('%02u:%02u', hour, minute), 0, 1, 0, 1, 1, 1);
				elseif (cHour > hour or (cHour == hour and cMin > minute)) then
				 	-- too late
				 	GameTooltip:AddDoubleLine(title, string.format('%02u:%02u', hour, minute), 1, 0, 0, 1, 1, 1);
				else
					-- just in time, but closing in fast ( < 1 hour to go)
				 	GameTooltip:AddDoubleLine(title, string.format('%02u:%02u', hour, minute), 1, 1, 0, 1, 1, 1);
				end;
				hasEntries = true;
			end;
    	end;
    	
    	if(not hasEntries) then
    		GameTooltip:AddLine("none", 1, 0, 0);
    	 end;
    end;
    
    GameTooltip:AddLine('Hint: left-click to open the in-game calendar.', 0, 1, 0);
end;

function CalendarFu:OnFuBarClick(button)
	if (not IsAddOnLoaded("Blizzard_Calendar")) then
		UIParentLoadAddOn("Blizzard_Calendar");
	end;
	Calendar_Toggle();
end;